<template>
  <view-new
    :status="status"
    title="Dodaj element wyposażenia"
    sentTitle="Nowy element wyposażenia został dodany"
    :back="BACK"
  >
    <input-form v-on:submit.prevent="on_submit">
      <input-text-field
        :error="get_error_for('name')"
        name="Nazwa"
        v-model="name"
        type="text"
        size="2"
      />
      <input-text-field
        :error="get_error_for('part_number')"
        name="Numer katalogowy"
        v-model="part_number"
        type="text"
      />
      <input-text-field
        :error="get_error_for('serial_number')"
        name="Numer seryjny"
        v-model="serial_number"
        type="text"
      />
      <input-dynamic-select
        :error="get_error_for('location_id')"
        v-model="location_id"
        name="Lokalizacja"
        :list="locations"
        size="2"
      />
      <input-text-area
        :error="get_error_for('description')"
        name="Opis"
        v-model="description"
        size="2"
      />
      <div
        v-for="error in errors.filter((e) => e.field == null)"
        :style="{ gridColumnEnd: `span 2` }"
        :key="error.error"
        class="error"
      >
        {{ error.error }}
      </div>
      <input-button
        text="Dodaj element wyposażenia"
        :spinner="status == formStatus.sending"
        size="2"
      />
    </input-form>
  </view-new>
</template>

<script lang="ts">
import { Options, Vue } from "vue-class-component";

import NewRecord from "@/views/new-views/NewRecord.ts";

import InputButton from "@/components/input/InputButton.vue";
import InputForm from "@/components/input/InputForm.vue";
import InputTextField from "@/components/input/InputTextField.vue";
import InputRadio from "@/components/input/InputRadio.vue";
import InputTextArea from "@/components/input/InputTextArea.vue";
import InputDynamicSelect from "@/components/input/select/InputDynamicSelect.vue";

import { NewItemData, LocationData, NewUserData } from "@/interfaces";

import ViewNew from "@/views/new-views/ViewNew.vue";
import { NApi } from "@/interfaces/connector";

@Options({
  components: {
    ViewNew,
    InputButton,
    InputForm,
    InputTextField,
    InputRadio,
    InputTextArea,
    InputDynamicSelect,
  },
})
export default class NewItem
  extends NewRecord<NewItemData, null>
  implements NewItemData {
  public API_CALL = NApi.newItem;
  public BACK = "/wyposazenie";

  public name = "";
  public part_number = "";
  public serial_number = "";
  public description = "";
  public location_id = 0;

  public locations: { id: number; display_name: string }[] = [];

  public mounted() {
    console.log("mounted new item");
    this.load_locations();
  }

  public get_data = () => ({
    name: this.name,
    part_number: this.part_number,
    serial_number: this.serial_number,
    description: this.description,
    location_id: this.location_id,
  });

  public load_locations = async () => {
    try {
      const data: LocationData[] = await NApi.getLocations();

      for (const { id, name, type, street } of data) {
        this.locations.push({
          id,
          display_name: `${name} ${street} (${type})`,
        });
      }
    } catch (e) {
      console.log(e);
    }
  };
}
</script>

<style lang="scss" scoped>
@import "@/styles/globals";

.error {
  color: $red;
  font-size: 10px;
}
</style>
